//C-  -*- C++ -*-
//C-
//C- DjVu Unix Viewer (v. 3.5)
//C- 
//C- Copyright  1999-2001 LizardTech, Inc. All Rights Reserved.
//C- The DjVu Reference Library is protected by U.S. Pat. No.
//C- 6,058,214 and patents pending.
//C- 
//C- This software is subject to, and may be distributed under, the
//C- GNU General Public License, Version 2. The license should have
//C- accompanied the software or you may obtain a copy of the license
//C- from the Free Software Foundation at http://www.fsf.org .
//C- 
//C- The computer code originally released by LizardTech under this
//C- license and unmodified by other parties is deemed the "LizardTech
//C- Original Code."
//C- 
//C- With respect to the LizardTech Original Code ONLY, and subject
//C- to any third party intellectual property claims, LizardTech
//C- grants recipient a worldwide, royalty-free, non-exclusive license
//C- under patent claims now or hereafter owned or controlled by
//C- LizardTech that are infringed by making, using, or selling
//C- LizardTech Original Code, but solely to the extent that any such
//C- patent(s) is/are reasonably necessary to enable you to make, have
//C- made, practice, sell, or otherwise dispose of LizardTech Original
//C- Code (or portions thereof) and not to any greater extent that may
//C- be necessary to utilize further modifications or combinations.
//C- 
//C- The LizardTech Original Code is provided "AS IS" WITHOUT WARRANTY
//C- OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//C- TO ANY WARRANTY OF NON-INFRINGEMENT, OR ANY IMPLIED WARRANTY OF
//C- MERCHANTIBILITY OR FITNESS FOR A PARTICULAR PURPOSE.
//C-
// 
// $Id: qd_tbar_print_piece.cpp,v 1.3 2002/01/10 21:33:41 leonb Exp $
// $Name:  $

#ifdef __GNUG__
#pragma implementation
#endif
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "qd_tbar_print_piece.h"
#include "debug.h"
#include "qlib.h"
#include "qd_toolbutt.h"
#include "djvu_base_res.h"
#include "cin_data.h"



//****************************************************************************
//***************************** QDTBarPrintPiece *****************************
//****************************************************************************

void
QDTBarPrintPiece::setEnabled(bool en)
{
   print_butt->setEnabled(en);
   find_butt->setEnabled(en);
   save_butt->setEnabled(en);
}

QDTBarPrintPiece::QDTBarPrintPiece(QDToolBar * toolbar) : QDTBarPiece(toolbar)
{
   QFrame * frame;
   
   frame=new QFrame(toolbar, "separator");
   frame->setFrameStyle(QFrame::VLine | QFrame::Sunken);
   frame->setMinimumWidth(10);
   toolbar->addLeftWidget(frame);
   
   find_butt=new QDToolButton(*CINData::get("ppm_vfind"), true,
			      IDC_SEARCH, toolbar, tr("Find"));
   connect(find_butt, SIGNAL(clicked(void)), this, SIGNAL(sigFind(void)));
   toolbar->addLeftWidget(find_butt);

   print_butt=new QDToolButton(*CINData::get("ppm_vprint"), true,
			       IDC_PRINT, toolbar, tr("Print"));
   connect(print_butt, SIGNAL(clicked(void)), this, SIGNAL(sigPrint(void)));
   toolbar->addLeftWidget(print_butt);

   save_butt=new QDToolButton(*CINData::get("ppm_vsave"), true,
			      IDC_SAVE_DOC, toolbar, tr("Save"));
   connect(save_butt, SIGNAL(clicked(void)), this, SIGNAL(sigSave(void)));
   toolbar->addLeftWidget(save_butt);
   
   toolbar->addPiece(this);
   toolbar->adjustPositions();
}
